<?php
/**
* @version $Id: admin.bsbanner.php $ 
* @version		1.3.5 20/05/2015
* @package		bsbanner
* @author       Bernard Saulmé
* @copyright	Copyright (C) 2008-2009-2010-2011-2012-2013-2014-2015 Bernard Saulmé
* @license      GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
*/
// Fichier   : admin.bsbanner.php

// no direct access
defined('_JEXEC') or die('Restricted access');
if (!defined('DS')) define('DS', DIRECTORY_SEPARATOR);

require_once JPATH_ROOT.DS.'components'.DS.'com_bsbanner'.DS.'helpers'.DS.'version.php';

// Access check
if (version_compare(JVERSION, '1.6.0', 'ge') && !JFactory::getUser()->authorise('core.manage', 'com_bsbanner')) {
	return JError::raiseWarning(403, JText::_('JERROR_ALERTNOAUTHOR'));
}

// Create the controller
if (version_compare(JVERSION, '2.5.6', 'ge')) {
	$controller	= JControllerLegacy::getInstance('bsbanner');
} else {
	require_once (JPATH_COMPONENT.DS.'controller.php');
	if ($controller = JRequest::getVar('controller')) {
		require_once (JPATH_COMPONENT.DS.'controllers'.DS.$controller.'.php');
	}

	$classname	= 'BsbannerController'.$controller;
	$controller = new $classname();
}
// Perform the Request task
$controller->execute(JRequest::getCmd('task'));
// Redirect if set by the controller
$controller->redirect();

// Pour afficher Paramètres de configurations
if (version_compare(JVERSION, '1.6.0', 'ge'))
	JToolBarHelper::preferences('com_bsbanner');
else
	JToolBarHelper::preferences('com_bsbanner', 400, 875, JText::_('COM_BSBANNER_ADMIN_OPTIONS'), 'administrator/components/com_bsbanner/my_config.xml');
	
JToolBarHelper::divider();

// Help website
$help_url = BS_Helper_version::get_xml_item('com_bsbanner', 'authorUrl');
if (version_compare(JVERSION, '3.0.0', 'ge')) {
	JToolBarHelper::help(JText::_('COM_BSBANNER_HELP'), false, $help_url);
} else {
	$bar = JToolBar::getInstance('toolbar');
	$bar->appendButton('Popup', 'help', JText::_('COM_BSBANNER_HELP'), $help_url, 1024, 768);
}

?>
