<?php
/**
* @version $Id: controller.php $ 
* @version		1.3.5 29/11/2015
* @package		bsbanner
* @author       Bernard Saulmé
* @copyright	Copyright (C) 2008-2009-2010-2011-2012-2013-2014-2015 Bernard Saulmé
* @license      GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
*/

defined('_JEXEC') or die;
if (!defined('DS')) define('DS', DIRECTORY_SEPARATOR);

require_once JPATH_COMPONENT_SITE.DS.'helpers'.DS.'legacy.php';

jimport('joomla.application.component.controller');
jimport('joomla.html.parameter'); // J1.6

class BsbannerController extends JControllerLegacy
{
	function display($cachable = false, $urlparams = false)
	{
		$acces_ok = true;
	  	$user = JFactory::getuser();
		$get_view = JRequest::getCmd('view', '');

		// J! >= 1.6 ACL
		if (version_compare(JVERSION, '1.6.0', 'ge')) {
			// View
			if ($get_view != '' && !JFactory::getUser()->authorise('user.'.$get_view, 'com_bsbanner'))
				$acces_ok = false;
		}

		if ($acces_ok == false && !isset($user->username)) { // Redirect to login page
			$uri = JFactory::getURI();
			$return = $uri->toString();
			if (version_compare(JVERSION, '1.6.0', 'ge'))
				$url = 'index.php?option=com_users&view=login';
			else
				$url = 'index.php?option=com_user&view=login';
			$url .= '&return='.base64_encode($return); // Pour rediriger sur la page originellement appelee
			$this->setRedirect(JRoute::_($url, false));		
			return;
		} else if ($acces_ok == false && isset($user->username)) { // Not allowed
			$this->setRedirect('index.php', JText::_('BSBNR_NOT_ALLOWED'), 'error');
		}

		parent::display();
	}

	/**
	 * banner
	 * @return unknown_type
	 */
	 
	function cree()
	{
     	$model = $this->getModel();
		$user = JFactory::getuser();
		$id_tmp = $user->username;
		$app = JFactory::getApplication();	
		$params = $app->getParams();
		$signature = 0;

		if (isset($id_tmp) && isset($_POST)) {
			$retour = $model->cree_image_fichier($user, $_POST);
			if ($retour != 0 && $params->get('kunena_add_signature', 0) > 0) { // kunena signature ?
				$fichier = JPATH_COMPONENT_SITE.DS.'plugin'.DS.'plug_kunena'.DS.'kunena.php';
				if (file_exists($fichier)) {
					require_once $fichier;

					$instance = JRequest::getInt('instance', 1);
					if ($params->get('kunena_add_signature', 0) == 1)
						$kunena_add_signature_choice = $params->get('kunena_add_signature_choice', 2);
					else
						$kunena_add_signature_choice = JRequest::getInt('kunena_add_signature_choice', $params->get('kunena_add_signature_choice', 2));
					$signature = BS_kunena::update_signature($user, $instance, $kunena_add_signature_choice);
				}
			}
        }
		if ($retour != 0) {
			$app->enqueueMessage(JText::_('BSBNR_CTRL_NEW_BAN'));
			if ($signature)
				$app->enqueueMessage(JText::_('BSBNR_KUNENA_SIGNATURE_UPDATED'));

			$this->setRedirect(JRoute::_('index.php?option=com_bsbanner&view=bsbanner&instance='.$retour, false));
		} else
			$this->setRedirect(JRoute::_('index.php?option=com_bsbanner&view=edit', false), JText::_('BSBNR_CTRL_NEW_BAN_KO'), 'error');
	}
	 
	// Supprimer la vignette
	function supp()
	{
		$model = $this->getModel();
		$user = JFactory::getuser();
		$id_tmp = $user->username;
		$inst = JRequest::getVar('instance');

		if (isset($id_tmp) && $inst != null) {
			$retour = $model->supp_image_fichier($id_tmp, $inst);
		} 
		if ($retour == true)
			$this->setRedirect(JRoute::_('index.php?option=com_bsbanner&view=bsbanner&instance='.$inst, false), JText::sprintf('BSBNR_CTRL_SUP_BAN', $inst), 'message');
		else
			$this->setRedirect(JRoute::_('index.php?option=com_bsbanner&view=bsbanner&instance='.$inst, false), JText::sprintf('BSBNR_CTRL_SUP_BAN_KO', $inst), 'error');
	}

	// Supprimer les donnees (de l'instance)
	function suppdata()
	{
		$user = JFactory::getuser();
		$pparams = JComponentHelper::getParams('com_bsbanner');
		$plugin = $pparams->get('plugin', 'data_default');
		$inst = JRequest::getVar('instance', 0);
		$retour = false;

		$plugin_file = JPATH_COMPONENT_SITE.DS.'plugin'.DS.'plug_data_default'.DS.'data_default.php';
		if (file_exists($plugin_file))
			require_once $plugin_file;
		$plugin_file = JPATH_COMPONENT_SITE.DS.'plugin'.DS.'plug_'.$plugin.DS.$plugin.'.php';
		if (file_exists($plugin_file)) {
			require_once $plugin_file;
			
			// Nom plugin
			$nom_class = 'BS_'.$plugin;
			$mon_obj = new $nom_class;
			
			// Efface les donnees (de l'instance de l'utilisateur)
			$retour = $mon_obj->delete_data($user->id, $inst);
		}
		
		if ($retour == true)
			$this->setRedirect(JRoute::_('index.php?option=com_bsbanner&view=bsbanner&instance='.$inst, false), JText::sprintf('BSBNR_CTRL_SUP_BAN_DATA', $inst), 'message');
		else
			$this->setRedirect(JRoute::_('index.php?option=com_bsbanner&view=bsbanner&instance='.$inst, false), JText::sprintf('BSBNR_CTRL_SUP_BAN_DATA_KO', $inst), 'error');
	}
	
	// Exporte toutes les donnees de l'utilisateur
	function export() {

		$user = JFactory::getuser();
		$pparams = JComponentHelper::getParams('com_bsbanner');
		$plugin = $pparams->get('plugin', 'data_default');
		$data_user_export = $pparams->get('data_user_export', 1);
		$data_user_impexp_sep = $pparams->get('data_user_impexp_sep', ';');
		
		if ($data_user_export == 0)
			return;
			
		$basename = $_SERVER['HTTP_HOST'].'-'.date('YmdHis').'.csv'; // AJOUTER DATE YYYMMDDHHMMSS
//		$filesize = @filesize($filename);

//		while (@ob_end_clean());
//		@clearstatcache();

		// MIME headers
		header('MIME-Version: 1.0');
		header('Content-Disposition: attachment; filename='.$basename);
		header('Content-Transfer-Encoding: binary');
		header('Accept-Ranges: bytes');
			
		// Notify of filesize, if this info is available
//		if ($filesize > 0) header('Content-Length: '.@filesize($filename));
		// Disable cache
        header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
        header("Expires: 0");
		header('Pragma: no-cache');
		flush();

		$plugin_file = JPATH_COMPONENT_SITE.DS.'plugin'.DS.'plug_data_default'.DS.'data_default.php';
		if (file_exists($plugin_file))
			require_once $plugin_file;
		$plugin_file = JPATH_COMPONENT_SITE.DS.'plugin'.DS.'plug_'.$plugin.DS.$plugin.'.php';
		if (file_exists($plugin_file)) {
			require_once $plugin_file;
			
			// Nom plugin
			$nom_class = 'BS_'.$plugin;
			$mon_obj = new $nom_class;
			
			// Toutes les donnees de l'utilisateur
			$madata = $mon_obj->load_data_format($user->id, 0, 1, 0, null, null);
			echo $mon_obj->data_list_txt($madata, $data_user_impexp_sep, 0, JText::_('BSBNR_DATE_CALENDAR'));
			$madata = null; // Free memory 
		}
		exit(0);
	}
	
	// Importe des donnees de l'utilisateur
	function import() {
	
		$user = JFactory::getuser();
		$pparams = JComponentHelper::getParams('com_bsbanner');
		$plugin = $pparams->get('plugin', 'data_default');
		$data_user_import = $pparams->get('data_user_import', 1);
		$data_user_impexp_sep = $pparams->get('data_user_impexp_sep', ';');
		$instance =  JRequest::getVar('instance', 0);
		$data_user_import = $pparams->get('data_user_import', 1);
		$archive_data_user_nb = $pparams->get('archive_data_user_nb', 200);
		$archive_data_user_days = $pparams->get('archive_data_user_days', 200);

		if ($data_user_import == 0 || $instance == 0)
			return;
			
		if (isset($_FILES['userfile']['tmp_name']))
			$fichier = $_FILES['userfile']['tmp_name'];

		$plugin_file = JPATH_COMPONENT_SITE.DS.'plugin'.DS.'plug_data_default'.DS.'data_default.php';
		if (file_exists($plugin_file))
			require_once $plugin_file;
		$plugin_file = JPATH_COMPONENT_SITE.DS.'plugin'.DS.'plug_'.$plugin.DS.$plugin.'.php';
		if (file_exists($plugin_file)) {
			require_once $plugin_file;
			require_once JPATH_COMPONENT_SITE.DS.'models'.DS.'bsbanner.php';
			
			// Nom plugin
			$nom_class = 'BS_'.$plugin;
			$mon_obj = new $nom_class;
			
			$madata = $mon_obj->data_import($fichier, $data_user_impexp_sep, $archive_data_user_nb);
			$madata = BsbannerModelBsbanner::valid_data($madata, JText::_('BSBNR_DATE_CALENDAR'), 1); // Test format and transform formats
			$retour = $mon_obj->save_data_format($madata, $user->id, $instance);
			$madata = null; // Free memory as soon as possible
			@unlink($fichier); // Par secu, non indispensable
			$mon_obj->delete_exta_data($user->id, $archive_data_user_days, $archive_data_user_nb);
		}			

		if ($retour == 1)
			$this->setRedirect(JRoute::_('index.php?option=com_bsbanner&view=data', false), JText::_('BSBNR_MSG_DATA_IMPORT_OK'), 'message');
		else
			$this->setRedirect(JRoute::_('index.php?option=com_bsbanner&view=data', false), JText::_('BSBNR_MSG_DATA_IMPORT_KO'), 'error');
	}
	
}
?>
