<?php
/**
* @version $Id: router.php $
* @version		1.3.5 27/05/2015
* @package		com_bsbanner
* @author       Bernard Saulmé
* @copyright	Copyright (C) 2012-2013 Bernard Saulmé
* @license      GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die;

/**
 * @param	array	A named array
 * @return	array
 */
function BsbannerBuildRoute(&$query = null)
{
	$segments = array();

	if (isset($query['view'])) {
		$segments[] = $query['view'];
		unset($query['view']);
	}
	if (isset($query['id'])) {
		$segments[] = $query['id'];
		unset($query['id']);
	}

	return $segments;
}

/**
 * @param	array	A named array
 * @param	array
 *
 * Formats:
 *
 * index.php?/bsbanner/view/id/Itemid
 *
 * index.php?/bsbanner/id/Itemid
 */
function BsbannerParseRoute($segments = null)
{
	$vars = array();

	// view is always the first element of the array
	$count = count($segments);

	if ($count) {
		$count--;
		$segment = array_shift($segments);
		if (is_numeric($segment)) {
			$vars['id'] = $segment;
		} else {
			$vars['view'] = $segment;
		}
	}

	if ($count) {
		$count--;
		$segment = array_shift($segments) ;
		if (is_numeric($segment)) {
			$vars['id'] = $segment;
		}
	}

	return $vars;
}

?>
