<?php
/**
* @version $Id: view.html.php $ 
* @version		1.3.6 11/07/2015
* @package		bsbanner
* @author       Bernard Saulmé
* @copyright	Copyright (C) 2008-2009-2010-2011-2012-2013-2014-2015 Bernard Saulmé
* @license      GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
*/
defined('_JEXEC') or die('Restricted access');
if (!defined('DS')) define('DS', DIRECTORY_SEPARATOR);

require_once JPATH_COMPONENT_SITE.DS.'helpers'.DS.'legacy.php';
require_once JPATH_COMPONENT_SITE.DS.'helpers'.DS.'helper.php';

jimport('joomla.application.component.view');
jimport('joomla.html.parameter'); // J!1.6

class BsbannerViewBsbanner extends JViewLegacy
{
	function display($tpl = null)
	{
		$user = JFactory::getuser();
		$this->assignRef('username', $user->username);

		if (isset($user->username)) {
			$pparams = JComponentHelper::getParams('com_bsbanner');

			$mon_site_aff_pub = $pparams->get('mon_site_aff_pub', '');
			$nb_instance = $pparams->get('nb_instance', 1);
			$section_top = $pparams->get('section_top', '');
			$section_bottom = $pparams->get('section_bottom', '');

			$inst = JRequest::getVar('instance', '1');
			$img_file_rep = $pparams->get('fichier_image_rep', 'images/').$user->username.'-'.$inst.'.png';
			if (!file_exists(JPATH_ROOT.DS.$img_file_rep)) {
				$url_img1 = null;
				$url_img2 = null;
			} else {
				$heure_now = time(); // Pour forcer le rafraichissement de l'affichage de l'image
				$url_img1 = JURI::base().$img_file_rep;
				$url_img2 = $url_img1.'?t='.$heure_now;
			}

			// Liste des fichiers images pour l'utilisateur
			$list_url = null;
			if ($nb_instance > 1) {
				for ($i = 1 ; $i <= $nb_instance ; ++$i) {
					$fichier = $pparams->get('fichier_image_rep','images/').$user->username.'-'.$i.'.png';
					if (file_exists($fichier)) {
						$url = htmlspecialchars('index.php?view=bsbanner&instance='.$i);
						$list_url .= '<a href="'.$url.'" >'.$i.'</a> ';
					}
				}
			}

			$this->assignRef('mon_site_aff_pub', $mon_site_aff_pub);
			$this->assignRef('url_img1', $url_img1);
			$this->assignRef('url_img2', $url_img2);
			$this->assignRef('inst', $inst);
			$this->assignRef('list_url', $list_url);
			$this->assignRef('nb_instance', $nb_instance);
			$this->assignRef('section_top', $section_top);
			$this->assignRef('section_bottom', $section_bottom);
		}
		
		parent::display($tpl);
	}

	function display_module($module_name, $style = 'none') {
		BS_helper::display_module($module_name, $style);
	}
}
?>
