<?php
/**
* @version $Id: view.html.php $ 
* @version		1.3.6 11/07/2015
* @package		bsbanner
* @author       Bernard Saulmé
* @copyright	Copyright (C) 2008-2009-2010-2011-2012-2013-2014-2015 Bernard Saulmé
* @license      GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
*/

defined('_JEXEC') or die('Restricted access');
if (!defined('DS')) define('DS', DIRECTORY_SEPARATOR);

require_once JPATH_COMPONENT_SITE.DS.'helpers'.DS.'legacy.php';
require_once JPATH_COMPONENT_SITE.DS.'helpers'.DS.'helper.php';

jimport('joomla.application.component.view');
jimport('joomla.html.parameter'); // J!1.6

/**
 * HTML View pour Data de la banniere
 * @package    Bsbanner
 */

class BsbannerViewData extends JViewLegacy
{
	function display($tpl = null)
	{
		// User info
		$user = JFactory::getuser();
		
		if (isset($user->username)) {		
			// Config
			$pparams = JComponentHelper::getParams('com_bsbanner');

			$plugin = $pparams->get('plugin', 'data_default');
			$nb_instance = $pparams->get('nb_instance', 1);
			$archive_data_user_nb_print = JRequest::getVar('nbligne', '0');
			if ($archive_data_user_nb_print == '0')
				$archive_data_user_nb_print = $pparams->get('archive_data_user_nb_print', 100);
			else
				$archive_data_user_nb_print = min(JRequest::getVar('nbligne', 0), $pparams->get('archive_data_user_nb_print', 100));
			$section_top = $pparams->get('section_top', '');
			$section_bottom = $pparams->get('section_bottom', '');
			
			// Mode affichage
			$mode = JRequest::getVar('mode', ''); // html, graphique, ....
			$trie = JRequest::getVar('trie', ''); // trie ou pas
			$mescolonnes = JRequest::getVar('mescolonnes', Array (0 => 1)); // colonnes selectionnées (la premiere par defaut)

			// Recup paramètres utilisateurs en cookies	pour l'instance ou en url
			$id_cookie = $user->username.'-';
			$instance = JRequest::getVar('instance', '');
			if ($instance == '' && isset($_COOKIE[$id_cookie.'instance']) && $_COOKIE[$id_cookie.'instance'] != '')
				$instance = $_COOKIE[$id_cookie.'instance'];
			if ($instance == '')
				$instance = '1';

			// Format dates
			$date_fmt_tab = explode(' ', JText::_('BSBNR_DATE_CALENDAR'));
			$date_fmt = $date_fmt_tab[0]; // Date sans heures
			$date_fmt_hms = JText::_('BSBNR_DATE_CALENDAR');
	
			// Date début
			$date_deb = JRequest::getVar('date_deb', '');
			if (($date_deb_us = $this->verif_date($date_deb, $date_fmt))) { // test et retourne format us si ok, sinon nul
				$date_deb_us = $date_deb_us.' 00:00:00';
			} else {
				$date_deb = date($date_fmt, mktime(0, 0, 0, 1, 1));
				$date_deb_us = date('Y').'-01-01 00:00:00';
			}

			// Date fin
			$date_fin = JRequest::getVar('date_fin', '');
			if ($date_fin_us = $this->verif_date($date_fin, $date_fmt)) { // test et retourne format us si ok, sinon nul
				$date_fin_us = $date_fin_us.' 23:59:59';
			} else {
				$date_fin = null;
				$date_fin_us = null;
			}

			// Données
			$data = '';
			$param = '';

			$plugin_file = JPATH_COMPONENT_SITE.DS.'plugin'.DS.'plug_data_default'.DS.'data_default.php'; // Model
			if (file_exists($plugin_file))
				require_once $plugin_file;
			$plugin_file = JPATH_COMPONENT_SITE.DS.'plugin'.DS.'plug_'.$plugin.DS.$plugin.'.php'; // Plugin
			if (file_exists($plugin_file)) {
				require_once $plugin_file;

				// Nom plugin
				$nom_class = 'BS_'.$plugin;
				$mon_obj = new $nom_class;

				if ($mode == '')
					$mode = $mon_obj->mode_defaut;
				if ($trie == '')
					$trie = $mon_obj->trie_defaut;
				$mon_obj->aff_import = $pparams->get('data_user_import', 1);
				$mon_obj->aff_export = $pparams->get('data_user_export', 1);

				// Controle typage des saisies possibles en url
				$mode = intval($mode);
				$trie = intval($trie);
				$archive_data_user_nb_print = intval($archive_data_user_nb_print);
				$instance = intval($instance);

				$mon_obj->val_instance = $instance;

				// Actions :-)
				$madata = $mon_obj->load_data_format($user->id, $instance, $mode, $archive_data_user_nb_print, $date_deb_us, $date_fin_us);
				$tab_mode = $mon_obj->tab_mode();
				$mon_obj->aff_tab_select_ckeck = $mescolonnes;

				// Datas
				$data = $mon_obj->data_aff($mode, $madata, $trie, $archive_data_user_nb_print, $date_fmt_hms); // Données ordre décroissants si affichés en 'texte'

				// Param
				if ($data != '')
					$param = $mon_obj->param_aff($nb_instance, $instance, $date_deb, $date_fin, $tab_mode, $mode, $trie, $archive_data_user_nb_print, $date_fmt); // Les paramètres par défaut

				// Import export
				if ($data != '')
					$impexp = $mon_obj->impexp_aff();
			}			

			if (!$data)
				$data =  JText::_('BSBNR_MSG_DATA_EMPTY');

			// Contenu
			$this->assignRef('param', $param);
			$this->assignRef('data', $data);
			$this->assignRef('impexp', $impexp);
			$this->assignRef('section_top', $section_top);
			$this->assignRef('section_bottom', $section_bottom);

			parent::display($tpl);
		
		}
	}

	function display_module($module_name, $style = 'none') {
		BS_helper::display_module($module_name, $style);
	}

	// Verifie la date, la retourne au format US si ok et null si ko
	function verif_date($madate, $date_fmt) {
	
		// Vérification que la date est date correcte et transformation de format
		if (version_compare(PHP_VERSION, '5.3.0') >= 0) { // J'ai au moins la version 5.3.0 de PHP
			if ($date = DateTime::createFromFormat($date_fmt, $madate))
				$madate = $date->format('Y-m-d');
			else
				$madate = null;
		} else { // Faute de mieux :-)
			$date_tmp = str_replace('/', '-', $madate);
			$madate = date('Y-m-d', strtotime($madate));
		}
		
	// Ajouter un test : date recu = (transforme au format apres transformation formet us)
		
		// Sinon date-heure actuelle par défaut
		if ($madate == '1970-01-01' || $madate == '0000-00-00')
			$madate = null;

		return $madate;
	}
}
?>