<?php
/**
* @version $Id: view.html.php $ 
* @version		1.3.5 20/05/2015
* @package		bsbanner
* @author       Bernard Saulmé
* @copyright	Copyright (C) 2008-2009-2010-2011-2012-2013-2014-2015 Bernard Saulmé
* @license      GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
*/

defined('_JEXEC') or die('Restricted access');
if (!defined('DS')) define('DS', DIRECTORY_SEPARATOR);

require_once JPATH_COMPONENT_SITE.DS.'helpers'.DS.'legacy.php';

jimport('joomla.application.component.view');
jimport('joomla.html.parameter'); // J1.6

/**
 * HTML Info sur la banniere
 * @package    Bsbanner
 */

class BsbannerViewDoc extends JViewLegacy
{
	function display($tpl = null)
	{
        require_once JPATH_COMPONENT_SITE.DS.'helpers'.DS.'version.php';

		$pparams = JComponentHelper::getParams('com_bsbanner');

		$plugin = $pparams->get('plugin', 'data_default');
		$image_fond_util = $pparams->get('image_fond_util', '307200');
		$image_fond_util_url = $pparams->get('image_fond_util_url', '307200');
		$archive_data_user_cookie = intval($pparams->get('archive_data_user_cookie', '1'));
		$archive_data_user_days = $pparams->get('archive_data_user_days', 365);
		$archive_data_user_nb = $pparams->get('archive_data_user_nb', 100);

		// Language
		$my_language = JRequest::getVar('lang', '', "REQUEST");
		$lang_tmp = JFactory::getLanguage();
		if ($my_language == '') 
			$my_language = substr($lang_tmp->get('tag'),0,strrpos($lang_tmp->get('tag'),'-'));
		if ($my_language == '')
			$my_language = 'en';

		$fichier = JPATH_COMPONENT_SITE.DS.'views'.DS.'doc'.DS.'tmpl'.DS.'doc-'.$my_language.'.php';
		$this->assignRef('fichier',$fichier);

		// Version
		$version = BS_Helper_version::get_version();
		$this->assignRef('version', $version);

		$this->assignRef('plugin', $plugin);
		$this->assignRef('image_fond_util', $image_fond_util);
		$this->assignRef('image_fond_util_url', $image_fond_util_url);
		$this->assignRef('archive_data_user_cookie', $archive_data_user_cookie);
		$this->assignRef('archive_data_user_days', $archive_data_user_days);
		$this->assignRef('archive_data_user_nb', $archive_data_user_nb);

		parent::display($tpl);
	}
}
?>