<?php
/**
* @version $Id: view.html.php $ 
* @version		1.3.6 11/07/2015
* @package		bsbanner
* @author       Bernard Saulmé
* @copyright	Copyright (C) 2008-2009-2010-2011-2012-2013-2014-2015 Bernard Saulmé
* @license      GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
*/

defined('_JEXEC') or die('Restricted access');
if (!defined('DS')) define('DS', DIRECTORY_SEPARATOR);

require_once JPATH_COMPONENT_SITE.DS.'helpers'.DS.'legacy.php';
require_once JPATH_COMPONENT_SITE.DS.'helpers'.DS.'helper.php';

jimport('joomla.application.component.view');
jimport('joomla.html.parameter'); // J!1.6

/**
 * HTML View data imput
 * @package    Bsbanner
 */

class BsbannerViewEdit extends JViewLegacy
{
	function display($tpl = null)
	{
		// User info
		$user = JFactory::getuser();
		$this->assignRef('username', $user->username);
		
		// User identified (sec.)
		if (isset($user->username)) {
			require_once JPATH_COMPONENT_SITE.DS.'models'.DS.'bsbanner.php';		

			// Config
			$pparams = JComponentHelper::getParams('com_bsbanner');

			$edit_link = $pparams->get('edit_link', 1);
			$nb_ligne_saisie = $pparams->get('nb_ligne_saisie', 20);
			$inclure_val_param = $pparams->get('inclure_val_param', 1);
			$nb_instance = $pparams->get('nb_instance', 1);
			$plugin = $pparams->get('plugin', 'data_default');
			$section_top = $pparams->get('section_top', '');
			$section_bottom = $pparams->get('section_bottom', '');

			// Date
			$edit_date = $pparams->get('edit_date', 1);
			$date_tmp = date(JText::_('BSBNR_DATE_CALENDAR'));

			// Le fichier des parametres couleurs/libelle (pour afficher des valeurs par defaut)
			$fichier_include = 'components'.DS.'com_bsbanner'.DS.'models'.DS.'#ref-image.conf2.php';				
			// Si fichier de données à inclure, alors charge sinon donnees vides
			if ($inclure_val_param == 1 && file_exists($fichier_include)) {
				include($fichier_include);
			} else {
				$maconf = array();
				$maconf[1]['id'] = ''; // pour avoir une ligne, même vide :-)
				$maconf[1]['img'] = 1;
			}
			// Constitution de la liste unique de libellés à afficher à partir de la configuration
			$nb_conf = count($maconf);
			for ($i = 1 ; $i <= $nb_conf ; ++$i) {
				$maconf_unique0[ $maconf[$i]['id'] ] = $maconf[$i]['img']; 			
			}
			$i = 1;
			foreach($maconf_unique0 as $key=>$val) {   
				$maconf_unique1[$i]['id'] = $key;
				$maconf_unique1[$i]['img'] = $val;
				$i++;
			}

			// Parametres image (config admin)
			$maparam = BsbannerModelBsbanner::charge_param();

			// Instance
			$maparam["instance"] = JRequest::getVar('instance', '');

			// Recup paramètres utilisateurs en cookies	
			if ($pparams->get('archive_data_user_cookie','1') == '1') {
				$id_cookie = $user->username.'-';

				if ($maparam['instance'] == '' && isset($_COOKIE[$id_cookie.'instance']) && $_COOKIE[$id_cookie.'instance'] != '')
					$maparam['instance'] = $_COOKIE[$id_cookie.'instance'];
				if ($maparam['instance'] == '')				
					$maparam['instance'] = '1';

				$id_cookie = $user->username.'-'.$maparam['instance'].'-';
				if (isset($_COOKIE[$id_cookie.'image_couleur_texte']) && $_COOKIE[$id_cookie.'image_couleur_texte'] != '')
					$maparam['image_couleur_texte'] = $_COOKIE[$id_cookie.'image_couleur_texte'];
				if (isset($_COOKIE[$id_cookie.'image_couleur_fond'])  && $_COOKIE[$id_cookie.'image_couleur_fond'] != '')
					$maparam['image_couleur_fond'] = $_COOKIE[$id_cookie.'image_couleur_fond'];
				if (isset($_COOKIE[$id_cookie.'image_transparente']) && $_COOKIE[$id_cookie.'image_transparente'] != '')
					$maparam['image_transparente'] = $_COOKIE[$id_cookie.'image_transparente'];
				if (isset($_COOKIE[$id_cookie.'image_couleur_fond_url']) && $_COOKIE[$id_cookie.'image_couleur_fond_url'])
					$maparam['image_couleur_fond_url'] = $_COOKIE[$id_cookie.'image_couleur_fond_url'];
			} else if ($maparam['instance'] == '') // Rien en param et pas de cookies !
				$maparam['instance'] = '1';

			// Nom fichier vignette   
			$img_file_rep = $pparams->get('fichier_image_rep', 'images/').$user->username.'-'.$maparam["instance"].'.png';
			if (!file_exists($img_file_rep))
				$img_file_rep = null;

			// Variables pour affichage
			$this->assignRef('maconf', $maconf_unique1);
			$this->assignRef('maparam', $maparam);
			$this->assignRef('edit_link', $edit_link);
			$this->assignRef('edit_date', $edit_date);
			$this->assignRef('id_cookie', $id_cookie);
			$this->assignRef('date_tmp', $date_tmp);
			$this->assignRef('img_file_rep', $img_file_rep);
			$this->assignRef('nb_ligne_saisie', $nb_ligne_saisie);
			$this->assignRef('nb_instance', $nb_instance);
			$this->assignRef('plugin', $plugin);
			$this->assignRef('section_top', $section_top);
			$this->assignRef('section_bottom', $section_bottom);
		}

		parent::display($tpl);
	}
	
	function display_module($module_name, $style = 'none') {
		BS_helper::display_module($module_name, $style);
	}
}

?>
